#!/usr/bin/php -q
<?PHP
// This script is a part of SmartPost software
// http://www.smartpost.ro
//
// Copyright (c)2003 Mikhail Tchoudinov
//	27.10.2003 version 1.1				
// This script transfers the XMail MTA users database to SmartPost infrastructure
// SmartPost database will be cleared by this script and filled again.
//

#########		CONFIGURATION SECTION		#######

############ XMAIL CONFIGURATION ############
$XMAILHOST = "localhost";
$XMAILADMINPORT = "6017";
//See ../MailRoot/ctrlaccounts.tab XMail config file
$XMAILADMINUSERNAME = "serveradmin";	//put your xmail admin username
$XMAILADMINPASSWORD = "serveradmin";	//put your xmail admin pwd

############ MYSQL CONFIGURATION ############
$MYSQLHOST = "localhost";	//hostname of the mysql server
$MYSQLUSER = "mailadmin";	//put your username for mysql
$MYSQLPASS = "mysql";		//put your password for mysql
$DBNAME = "mailtest";		//mysql database name

$CONFIGURED = "NO";			//Set this to "YES" when done configuration
#########	END CONFIGURATION SECTION		#######



#########	XMail MTA functions group		#######
//Execute XMail commands
function execute($cmd, $ret_type, $vars=''){
  global $XMAILHOST,$XMAILADMINPORT,$XMAILADMINUSERNAME,$XMAILADMINPASSWORD;

	$fp = fsockopen($XMAILHOST,$XMAILADMINPORT, $errno, $errstr, 5);
	if (!$fp) {die($errstr);}

	fgets($fp, 1024); //read server info

	fputs($fp,$XMAILADMINUSERNAME."\t".$XMAILADMINPASSWORD."\n"); //send login info
	$ret = fgets($fp, 2048); //read login info
	if (ereg('-', $ret)) { //not logged in
		//die("error logging in");
		return FALSE;
		exit;
	}

	fputs($fp, "$cmd\n");		//send command
	$ret = fgets($fp,2048);		//read ret info
	if ($ret[0] == '-') {		//error exec command
		$nla=count($ret);
		echo " Command Failed : \n";
		for ($idx=0;$idx<128;++$idx){echo "$ret[$idx]";}
		echo "\n";
		return FALSE;
		exit;
	}

	switch ($ret_type) {
		case 0: //no more data expected from server
			return TRUE;
			break;

		case 1: //read data from server
			$ret = array();
			do { //read command output

				$tmp = fgetcsv($fp, 2048, "\t");
			if (count($tmp) == 1) {
					array_push($ret, $tmp[0]); //use first (only) element
				} else {
					array_push($ret, $tmp); //use all elements
				}
			} while ((substr($tmp[0], 0, 1) != '.'));
			array_pop($ret); // remove trailing dot
			return($ret);
			break;

		case 2: //send vars to server
			fputs($fp, "$vars.\n"); //send command
		$ret = fgets($fp, 2048); //read ret info
			if ($ret[0] == '-') { //error exec command
				return FALSE;
			} else {
				return TRUE;
			}
			break;
	}//End switch
} //end execute() function


//List all users
function userlist() {
	$cmd = "userlist\t$l_domain\t$l_editname";
	return (execute($cmd, 1));
} //end function


//List users in particular domain
function userlistdomain($l_domain) {
	$cmd = "userlist\t$l_domain";
	return (execute($cmd, 1));
} //end function


//No Operation
function noop() {
	$cmd = "noop\n";
	return (execute($cmd, 0));
}//end noop()


//Close connection to XMail
function quit() {
	$cmd = "quit\n";
	return (execute($cmd, 0));
}//end noop()


//Getting configuration file
function getconfigfile($filename){
	$cmd = "cfgfileget\t$filename";
	return (execute($cmd, 1));
}


//List handled domains
function domainlist(){
	$cmd = "domainlist\n";
	return (execute ($cmd, 1));
}


//List aliases
function aliaslist(){
	$cmd = "aliaslist\n";
	return (execute ($cmd, 1));
}


//Get user's variables
function uservars($l_domain, $l_editname) {
	$cmd = "uservars\t$l_domain\t$l_editname";
	return (execute($cmd, 1));
} //end function
#########	End XMail MTA functions group	#######



echo "\n This script will port your XMail user database to SmartPost infrastructure\n";
echo " ** YOUR SMARTPOST DATABASE WILL BE CLEARED BY THIS SCRIPT\n";
echo " ** Configure the script before use **\n"; 
echo " Just edit some variables in the beginning of this script.\n";

echo "-------------------------------------------------------------------\n";
echo " Your current configuration\n\n";
echo " XMail MTA configuration\n";
echo " XMail host - \t\t\t".$XMAILHOST."\n";
echo " XMail administrator port - \t".$XMAILADMINPORT."\n";
echo " XMail administartor name - \t".$XMAILADMINUSERNAME."\n";
echo " XMail administrator password - ".$XMAILADMINPASSWORD."\n\n";
echo " MySQL server configuration\n";
echo " MySQL host - \t\t\t".$MYSQLHOST."\n";
echo " MySQL user - \t\t\t".$MYSQLUSER."\n";
echo " MySQL password - \t\t".$MYSQLPASS."\n\n";
echo " SmartPost database name - \t".$DBNAME."\n";
echo "-------------------------------------------------------------------\n\n";

if ($CONFIGURED == "NO") {echo " You should configure the script before use.\n\n"; exit();}

//Test connection to XMail
echo " Connecting to XMail MTA ... ";
if (noop())	echo "OK\n";
else {echo "Could not connect to XMail\n"; exit();}


//Connection to database
echo " Connecting to SQL database ... ";
$link = mysql_pconnect($MYSQLHOST,$MYSQLUSER,$MYSQLPASS) 
		or die("Could not connect to SQL server\n");
IF (!@mysql_select_db($DBNAME)){echo "Could not connect to database\n"; exit();}
echo "OK\n";


//Clear SmartPost database structure
echo " Clearing ALL tables in ".$DBNAME." database ";
$sqlquery_truncate = array(		
'TRUNCATE TABLE adressbook;',			//0
'TRUNCATE TABLE aliaseslist;',			//1
'TRUNCATE TABLE domaindetails;',		//2
'TRUNCATE TABLE imapusers;',			//3
'TRUNCATE TABLE loginstats;',			//4
'TRUNCATE TABLE mailinglists;',			//5
'TRUNCATE TABLE newaccstats;',			//6
'TRUNCATE TABLE newsletters;',			//7
'TRUNCATE TABLE newslettersarchive;',	//8
'TRUNCATE TABLE notepad;',				//9
'TRUNCATE TABLE sendstats;',			//10
'TRUNCATE TABLE serveradmin;',			//11
);
foreach ($sqlquery_truncate as $query)
if (mysql_query($query))	echo ".";
else {echo " error ".$query."\n"; exit ();};
echo " OK\n";



//List handled domains and transfer into SmartPost SQL
echo "\n DOMAINS. Domains admins passwords are set the same as names.\n";
$i=0;
$domains = domainlist();	//Retrieve domains list
foreach ($domains as $dmn){	
	echo "\t".$dmn." -> ";
	
	//How many users in this domain? We have to filter mailing lists.
	$usersindomain = userlistdomain($dmn); $number=0;
	foreach ($usersindomain as $user)
		if($user[3]=='U') $number++; 

	$sqlquery= "INSERT INTO domaindetails  
	(domainname,postmasterpwd,maxusers,defaultinboxsize,allowsignup,existingnoofusers)
		VALUES ('$dmn','$dmn',1000,2048,'Y','$number')";

	if (mysql_query($sqlquery)) {$i++; echo "ok\n";}
	else {echo "error\n"; exit();}
}//End FOREACH
echo " ".$i." domains are processed\n";


//List users in domains and transfer into SQL
echo "\n USERS ACCOUNTS. Passwords are the same as in XMail.\n";
$i=0;
$accounts = userlist(); 
foreach ($accounts as $var){
	if ( ($var[3]=="U")||($var[3]=="u") ) {	//Filter users
		echo "\t".$var[1]."@".$var[0]." -> ";
		
		//Retrieve user's VARIABLES
		$vars = uservars($var[0],$var[1]);
		foreach ($vars as $v){
			if($v[0]=="RealName"){$completename=$v[1];}
			if($v[0]=="Address"){$addr1=$v[1];}
		}//End FOREACH
		
		if ( ($completename == "??")||($completename == "") ) $completename = $var[1];
		if ($addr1 == "??")	$addr1 = "";

		$sqlquery= "INSERT INTO imapusers
		(id,clear,home,maildir,domainname,completename,addr1,createdthrusignup)
		values('$var[1]@$var[0]','$var[2]','/var/MailRoot/domains/$var[0]/$var[1]',
		'/var/MailRoot/domains/$var[0]/$var[1]/Maildir','$var[0]',
		'$completename','$addr1','N');";

		if (mysql_query($sqlquery)) {$i++; echo "ok\n";}
		else {echo "error\n"; exit();}
	}//End IF
}//End FOREACH
echo " ".$i." users are processed\n";



//List aliases and transfer into SQL
echo "\n ALIASES.\n";
$i=0;
$aliases = aliaslist(); 
foreach ($aliases as $var){
	$aliasid = $var[1]."@".$var[0];
	$actualid = $var[2]."@".$var[0];
	echo "\t".$aliasid." - ".$actualid." -> ";
	
	$sqlquery= "INSERT INTO aliaseslist (aliasid, actualid) 
				VALUES ('$aliasid', '$actualid')";

	if (mysql_query($sqlquery)) {$i++; echo "ok\n";}
	else {echo "error\n"; exit();}
}//End FOREACH
echo " ".$i." aliases are processed\n";



//List mailinglists and transfer into SQL
echo "\n MAILINGLISTS. Maximum number of users is set to 1000\n";
$i=0;
$accounts = userlist(); 
foreach ($accounts as $var)	{
	if ( ($var[3]=="M")||($var[3]=="m") )	{
		echo "\t".$var[1]."@".$var[0]." -> ";
		//Calculating number of existing users in the current list
		$path2file = "domains/".$var[0]."/".$var[1]."/mlusers.tab";
		$members = getconfigfile($path2file); $j=0;
		foreach($members as $memb) $j++;
	
		$sqlquery= "INSERT INTO mailinglists (domain, mailinglist, maxmembers, noofexistingusers) 
				VALUES ('$var[0]','$var[1]','100','$j')";

		if (mysql_query($sqlquery)) {$i++; echo "ok\n";}
		else {echo "error\n"; exit();}
	}//End IF
}//End FOREACH
echo " ".$i." mailing lists are processed\n";



//Set SmartPost serveradmin login and password the same as XMail control account
echo "\n Set SmartPost serveradmin login and password the same as XMail control account... ";
$sqlquery= "INSERT INTO serveradmin (name, apassword) 
			VALUES ('$XMAILADMINUSERNAME','$XMAILADMINPASSWORD')";

if (mysql_query($sqlquery)) {echo "OK\n";}
else {echo "error\n"; exit();}
echo " You can change this login/password later.\n"; 
echo " Generally, this SmartPost account is independent from XMail control account.\n";
echo " Domains admins passwords are set the same as domains names.\n";

//$sqlquery= "SELECT * FROM domaindetails WHERE domainname='$dmn';";
//$query = mysql_query($sqlquery);



########	Close Links		#######
//Close link to XMail
echo "\n Closing link to XMail ... ";
if (quit()) echo "closed OK\n";
else {echo "could not close connect to XMail\n"; exit();}

//Close link to MySQL
echo " Closing link to MySQL ... ";
if (mysql_close($link)) echo "closed OK\n\n";
else {echo "could not close connect to database\n"; exit();}
#######	End Close Links		#######


echo " Done.\n\n";

?>